<?php

$data_manager = new NNR_Data_Manager_v1( self::$data_manager_table_name );
$data_manager_settings = new NNR_Data_Manager_Settings_v1(self::$prefix_dash, self::$text_domain);
$display_conditions_settings = new NNR_Display_Conditions_Settings_v1(self::$prefix_dash, self::$text_domain);

$settings = self::default_data();

// Edit Data

if ( isset($_GET['action']) && $_GET['action'] == 'edit' && isset($_GET['data_id']) && $_GET['data_id'] != '' ) {
	$settings = $data_manager->get_data_from_id($_GET['data_id']);
}

$display_conditions = $settings['display_conditions'];
$args = $settings['args'];

// Save data and check nonce

if (isset($_POST['submit']) && check_admin_referer(self::$prefix . 'admin_settings')) {

	// Get Data

	$data = $data_manager_settings->get_data();
	$display_data = $display_conditions_settings->get_data();

	// Add Data

	if ( !isset($settings['args']) || !is_array($settings['args']) ) {
		$settings['args'] = array();
	}

	$settings = array_merge($settings, $data);
	$settings['display_conditions'] = $display_data;

	// General Settings

	$settings['args']['content_type'] = isset($_POST[self::$prefix_dash . 'content-type']) ? $_POST[self::$prefix_dash . 'content-type'] : 'ad';

	$settings['args']['powered_by'] = isset($_POST[self::$prefix_dash . 'powered-by']) && $_POST[self::$prefix_dash . 'powered-by'] ? true : false;

	$settings['args']['tracking_code'] = isset($_POST[self::$prefix_dash . 'tracking-code']) ? stripcslashes(htmlentities($_POST[self::$prefix_dash . 'tracking-code'])) : '';

	$settings['args']['placement'] = isset($_POST[self::$prefix_dash . 'placement']) ? stripcslashes(htmlentities($_POST[self::$prefix_dash . 'placement'])) : 'top';

	$settings['args']['paragraphs'] = isset($_POST[self::$prefix_dash . 'paragraphs']) ? stripcslashes(htmlentities($_POST[self::$prefix_dash . 'paragraphs'])) : '1';

	// Self Hosted Ad

	$settings['args']['ad_type'] = isset($_POST[self::$prefix_dash . 'ad-type']) ? sanitize_text_field($_POST[self::$prefix_dash . 'ad-type']) : '';

	$settings['args']['ad_image'] = isset($_POST[self::$prefix_dash . 'ad-image']) ? sanitize_text_field($_POST[self::$prefix_dash . 'ad-image']) : '';

	$settings['args']['ad_image_link'] = isset($_POST[self::$prefix_dash . 'ad-image-link']) ? sanitize_text_field($_POST[self::$prefix_dash . 'ad-image-link']) : '';

	$settings['args']['ad_destination_link'] = isset($_POST[self::$prefix_dash . 'ad-destination-link']) ? sanitize_text_field($_POST[self::$prefix_dash . 'ad-destination-link']) : '';

	$settings['args']['ad_destination_target'] = isset($_POST[self::$prefix_dash . 'ad-destination-target']) ? sanitize_text_field($_POST[self::$prefix_dash . 'ad-destination-target']) : '';

	$settings['args']['ad_destination_rel'] = isset($_POST[self::$prefix_dash . 'ad-destination-rel']) && $_POST[self::$prefix_dash . 'ad-destination-rel'] ? true : false;

	// Third Party Ad

	$settings['args']['third_ad_code'] = isset($_POST[self::$prefix_dash . 'third-ad-code']) ? stripcslashes(htmlentities($_POST[self::$prefix_dash . 'third-ad-code'])) : '';

	// Button Link

	$settings['args']['button_text'] = isset($_POST[self::$prefix_dash . 'button-text']) ? stripcslashes(sanitize_text_field($_POST[self::$prefix_dash . 'button-text'])) : '';

	$settings['args']['button_link'] = isset($_POST[self::$prefix_dash . 'button-link']) ? sanitize_text_field($_POST[self::$prefix_dash . 'button-link']) : '';

	$settings['args']['button_target'] = isset($_POST[self::$prefix_dash . 'button-target']) ? sanitize_text_field($_POST[self::$prefix_dash . 'button-target']) : '';

	$settings['args']['button_rel'] = isset($_POST[self::$prefix_dash . 'button-rel']) && $_POST[self::$prefix_dash . 'button-rel'] ? true : false;

	$settings['args']['button_background_color'] = isset($_POST[self::$prefix_dash . 'button-background-color']) ? sanitize_text_field($_POST[self::$prefix_dash . 'button-background-color']) : '';

	$settings['args']['button_text_color'] = isset($_POST[self::$prefix_dash . 'button-text-color']) ? sanitize_text_field($_POST[self::$prefix_dash . 'button-text-color']) : '';


	if ( isset($_GET['action']) && $_GET['action'] == 'edit' ) {

		$data_manager->update_data($_GET['data_id'], $settings);

		// Redirect to the same page

		?>
		<script type="text/javascript">
			window.location = window.location;
		</script>
		<?php

	} else {

		$data_manager->add_data($settings);

		// Redirect to the dashboard page after the creatation of something

		?>
		<script type="text/javascript">
			window.location = "<?php echo get_admin_url(); ?>admin.php?page=<?php echo self::$dashboard_page; ?>&status_type=success&status_message=<?php echo urlencode(__("Please note that the AD you just created is not activated yet.  To activate it simply click the activate button to the left of the AD on this page. This is to prevent accidental publication.", self::$text_domain)); ?>";
		</script>
		<?php
	}
}

include_once(NNROBOTS_ADS_IN_POSTS_PLUGIN_DIR . 'views/add-edit.php');