jQuery(document).ready(function($){

	// Track Impression

	$(window).on('load resize scroll', function() {
		$('.' + nnr_aip_data.prefix + 'wrap').each(function(){
			nnr_aip_did_see_ad($(this));
		});
	});

	// Track Conversion

	$('.' + nnr_aip_data.prefix + 'ad-link').click(function(){
		nnr_aip_record_conversion($(this).closest('.' + nnr_aip_data.prefix + 'wrap').data('id'));
	});

	$('.' + nnr_aip_data.prefix + 'button-link').click(function(){
		nnr_aip_record_conversion($(this).closest('.' + nnr_aip_data.prefix + 'wrap').data('id'));
	});

	// Move to correct spot

	$('.' + nnr_aip_data.prefix + 'wrap').each(function(){
		if ( $(this).data('placement') == 'paragraphs' ) {

			var paragraphs = $(this).data('paragraphs');

			if (paragraphs > $('.entry-content').children('p').length) {
				paragraphs = $('.entry-content').children('p').length;
			}

			$(this).insertAfter(".entry-content > p:nth-of-type(" + paragraphs + ")");
		}
	});

	/**
	 * Records an impression
	 *
	 * @access public
	 * @return void
	 */
	function nnr_aip_record_impression(data_id) {

		$.post(nnr_aip_data.ajaxurl, {
				'action': 'nnr_stats_record_impression_v1',
				'data_id': data_id,
				'table_name': nnr_aip_data.stats_table_name
			}, function(response) {

			console.log(response);
		});

	}

	/**
	 * Records a conversion
	 *
	 * @access public
	 * @return void
	 */
	function nnr_aip_record_conversion(data_id) {

		$.post(nnr_aip_data.ajaxurl, {
				'action': 'nnr_stats_record_conversion_v1',
				'data_id': data_id,
				'table_name': nnr_aip_data.stats_table_name
			}, function(response) {

			console.log(response);
		});

	}

	/**
	 * Check if AD has been seen
	 *
	 * @access public
	 * @param mixed el
	 * @return void
	 */
	function nnr_aip_did_see_ad(wrap) {

	    if (!$(wrap).hasClass(nnr_aip_data.prefix + 'seen') && nnr_aip_is_in_viewport(wrap)) {

			nnr_aip_record_impression(wrap.data('id'));

			$(wrap).addClass(nnr_aip_data.prefix + 'seen');
	    }

	}

	/**
	 * Determines if the Optin is in the viewport of not
	 *
	 * @access public
	 * @param mixed el
	 * @return void
	 */
	function nnr_aip_is_in_viewport(wrap) {

		if (typeof wrap.position().top !== 'undefined') {
			return wrap.position().top <= ($(window).scrollTop() + $(window).height());
		}

	    return false;
	}

});